/** This file contains the default DCP configuration.
 *  To override any values, please make your changes in dcp-site-config.js
 *  in the same directory as this file.
 */

return {
  scheduler: {
    location: url('https://scheduler.distributed.computer/'),
  },
  bank: {
    location: url('https://bank.distributed.computer/'),
  },
  portal: {
    location: url('https://portal.distributed.computer/'),
  },
  packageManager: {
    location: url('https://packages.distributed.computer/'),
  },

  standaloneWorker: {
    listen: url('tcp://localhost:9000/'),
    location: url('tcp://localhost:9000/'),
    friendLocation: alias('standaloneWorker.listen'),
    reloadBehaviour: 'process.exit(12)',
    docRoot: '/opt/dcp/'
  },

  inetDaemon: {
    standaloneWorker: {
      net: alias('standaloneWorker'),
      process: path.join(installLocation, 'bin', 'sa-worker-v8'),
      arguments: [
        '/opt/dcp/libexec/sa-worker-control.js',
        '-b/opt/dcp/libexec/v8'
      ],
    }
  },

  worker: {
    /* Note: all properties passed to web; no whitelist! */
    bootstrapFilename: 'workerBootstrap.js',
    bootstrapCacheTTL: 600000, /* ms */
    sliceTimeout: 1000 * 60 * 60 * 24, /* 1 day in ms */
    progressTimeout: 1000 * 30, /* 30s in ms */
    sliceOverfetchRatio: 1.5, // Ratio to overfetch slices by, e.g. given 10 workers it will fetch 1.5x -> 15 slices
    maxAllowedWorkers: 100,
  },

  installLocation: installLocation,
  runningLocation: runningLocation,
  isInstalled: isInstalled,
  build: 'release',
}
