/** 
 * @file        webpack-native-bridge.js
 *              Glue logic, polyfills, etc that allow us to write code which can be
 *              webpacked for a 'web' target without breaking necessary NodeJS functionality
 *              when run under NodeJS
 * @author      Wes Garland, wes@kingsds.network
 * @date        Aug 2019
 */
/** @todo XXX this needs to be a proxy to support requireNative.paths, requireNative.id, etc /wg oct 2019 */
exports.requireNative = function webpackNativeBridge$$requireNative$placeholder() {
  let requireNative = eval('typeof require === "function" && require') /* hide deps from WebPack, fall through to Node or BravoJS */
  
  if (!requireNative) {
    console.error('There is no native require() on this platform')
  }
  return requireNative.apply(this, arguments)
}

if (!eval('typeof require === "function"'))
  delete exports.requireNative

const fakeModules = {
  process: { env: [] },
  fs: {},
  child_process: {}
}

Object.keys(fakeModules).forEach(function webpackNativeBridge$$export(moduleName) {
  try {
    exports[moduleName] = exports.requireNative(moduleName)     /* Node or BravoJS or other CommonJS environment: use underlying require */
  } catch(e) {
    exports[moduleName] = fakeModules[moduleName]       /* Webpack, but a module we have told webpack not to provide */
  }
})
